import { useState } from "react"
import React from "react"

const log = console.log
let cache: Array<any> = []
const clear = () => cache = []

const react18 = parseFloat(React.version) > 17

export default <T>(factory: () => T): T => {
    return useState(react18 ? factory : () => {
        if (log === console.log) {
            queueMicrotask(clear)
            const result = factory()
            cache.push(result)
            return result
        }
        return cache.shift()
    })[0]
}